SSL_SET_SESSION(3)

NAME
SSL_set_session - set a TLS/SSL session to be used during TLS/SSL connect

SYNOPSIS
#include <openssl/ssl.h>
int
SSL_set_session(SSL *ssl, SSL_SESSION *session);

DESCRIPTION
SSL_set_session() sets session to be used when the TLS/SSL connection is to be established. SSL_set_session() is only useful for TLS/SSL clients. When the session is set, the reference count of session is incremented by 1. If the session is not reused, the reference count is decremented again during SSL_connect(). Whether the session was reused can be queried with the SSL_session_reused(3) call.

If there is already a session set inside ssl (because it was set with SSL_set_session() before or because the same ssl was already used for a connection), SSL_SESSION_free(3) will be called for that session.

SSL_SESSION objects keep internal link information about the session cache list when being inserted into one SSL_CTX object's session cache. One SSL_SESSION object, regardless of its reference count, must therefore only be used with one SSL_CTX object (and the SSL objects created from this SSL_CTX object).

RETURN VALUES
The following return values can occur:

0   The operation failed; check the error stack to find out the reason.

1   The operation succeeded.

SEE ALSO
ssl(3), SSL_CTX_set_session_cache_mode(3), SSL_get_session(3), SSL_SESSION_free(3), SSL_session_reused(3)

HISTORY
SSL_set_session() first appeared in SSLeay 0.5.2 and has been available since OpenBSD 2.4.